﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using Verse;
using RimWorld;

namespace ChooseYourMedicine
{
    //We need to remove entries from our list of manually assigned medicines from time to time (e.g. if hediff does not exist anymore, pawn does not exist anymore)
    //We do it while/before saving

    class SaveGame_Prefix
    {
        public static void Prefix()
        {
            allSettledMaps = Current.Game.Maps;
            List<string> allPawnsHediffsIds = new List<string>();

            //get all pawns on maps
            if (allSettledMaps.Any())
            {
                foreach (Map map in allSettledMaps)
                {
                    if (map != null && map.mapPawns != null)
                    {
                        foreach (Pawn pawn in map.mapPawns.AllPawns)
                        {
                            foreach (Hediff hediff in pawn?.health?.hediffSet?.hediffs)
                            {
                                string hediffsID = hediff.GetUniqueLoadID();
                                allPawnsHediffsIds.Add(hediffsID);
                            }
                        }
                    }
                }
            }

            //get all pawns not on maps
            if (!Find.WorldPawns.AllPawnsAliveOrDead.NullOrEmpty())
            {
                foreach (Pawn pawn in Find.WorldPawns.AllPawnsAlive)
                {
                    foreach (Hediff hediff in pawn?.health?.hediffSet?.hediffs)
                    {
                            string hediffsID = hediff.GetUniqueLoadID();
                            allPawnsHediffsIds.Add(hediffsID);
                    }               
                }
            }

            //remove all unnecessary entries (hediffs that dont exist anymore, hediffs of pawns that dont exist anymore)
            List<int> indexes = new List<int>();
            foreach (HediffEntry entry in HediffEntryList.hediffEntries)
            {
                if (!allPawnsHediffsIds.Contains(entry.hediffUniqueLoadID))
                {
                    indexes.Add(HediffEntryList.hediffEntries.IndexOf(entry));
                }
            }
            if (indexes.Any())
            {
                //reverse, so we can remove while looping
                indexes.Reverse();
                foreach (int i in indexes)
                {
                    HediffEntryList.hediffEntries.RemoveAt(i);
                }
            }       
        }
        public static List<Map> allSettledMaps = new List<Map>();
    }









}
