﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using UnityEngine;

namespace ChooseYourMedicine
{
	public class MainTabWindow_Medicine_HelperGui : Window
	{
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(UI.screenWidth, UI.screenHeight);
			}
		}

		public MainTabWindow_Medicine_HelperGui()
		{
			this.forcePause = true;
			this.doCloseX = true;
			this.doCloseButton = true;
			this.closeOnClickedOutside = true;
			this.absorbInputAroundWindow = true;
			this.doWindowBackground = false;
			this.drawShadow = false;
			this.focusWhenOpened = false;
		}

		//The rect that gets used here is the rect/Vector2 we defined earlier contractedBy(Margin). Margin should be 18f...
		public override void DoWindowContents(Rect inRect)
		{
			Text.Font = GameFont.Small;

			if (UI.screenWidth < 1920)
			{
				Text.Font = GameFont.Tiny;
			}

			//How the mod decides which medicine is used
			//Manually assign medicine
			string textBox1 = "Kopp_CYM_HelperWhichMedicine1".Translate();
			//Rect rect1 = new Rect(450f, 200f, 314f, Text.CalcHeight(textBox1, 315f));
			Rect rect1 = new Rect(460f, 210f, 294f, Text.CalcHeight(textBox1, 294f));
			Rect rect1_1 = new Rect(rect1).ExpandedBy(10f);
			DrawWindowBackground1(rect1_1);
			Widgets.Label(rect1, textBox1);

			//Immunity lower
			string textBox2 = "Kopp_CYM_HelperWhichMedicine2".Translate();
			Rect rect2 = new Rect(1017f, 370f, 294f, Text.CalcHeight(textBox2, 294f));
			Rect rect2_1 = new Rect(rect2).ExpandedBy(10f);
			DrawWindowBackground1(rect2_1);
			Widgets.Label(rect2, textBox2);


			//Problematic
			string textBox3 = "Kopp_CYM_HelperWhichMedicine3".Translate();
			Rect rect3 = new Rect(702f, 530f, 294f, Text.CalcHeight(textBox3, 294f));
			Rect rect3_1 = new Rect(rect3).ExpandedBy(10f);
			DrawWindowBackground1(rect3_1);
			Widgets.Label(rect3, textBox3);

			//Easy
			string textBox4 = "Kopp_CYM_HelperWhichMedicine4".Translate();
			Rect rect4 = new Rect(222f, 690f, 294f, Text.CalcHeight(textBox4, 294f));
			Rect rect4_1 = new Rect(rect4).ExpandedBy(10f);
			DrawWindowBackground1(rect4_1);
			Widgets.Label(rect4, textBox4);

			//Standard
			string textBox5 = "Kopp_CYM_HelperWhichMedicine5".Translate();
			Rect rect5 = new Rect(537f, 850f, 144f, Text.CalcHeight(textBox5, 144f));
			Rect rect5_1 = new Rect(rect5).ExpandedBy(10f);
			DrawWindowBackground1(rect5_1);
			Widgets.Label(rect5, textBox5);


			//Others
			//
			string textBox6 = "Kopp_CYM_HelperCopyPaste".Translate();
			Rect rect6 = new Rect(1360f, 160f, 294f, Text.CalcHeight(textBox6, 294f));
			Rect rect6_1 = new Rect(rect6).ExpandedBy(10f);
			DrawWindowBackground(rect6_1);
			Widgets.Label(rect6, textBox6);

            string textBox7 = "Kopp_CYM_HelperLeftButtons".Translate();
            Rect rect7 = new Rect(10f, 160f, 294f, Text.CalcHeight(textBox7, 294f));
			Rect rect7_1 = new Rect(rect7).ExpandedBy(10f);
			DrawWindowBackground(rect7_1);
			Widgets.Label(rect7, textBox7);

			string textBox8 = "Kopp_CYM_HelperLabels".Translate();
			Rect rect8 = new Rect(10f, 530f, 191f, Text.CalcHeight(textBox8, 191f));
			Rect rect8_1 = new Rect(rect8).ExpandedBy(10f);
			DrawWindowBackground(rect8_1);
			Widgets.Label(rect8, textBox8);
		}


		//I wanted other background colors and was not sure how to do that... So this is a copy of vanilla
		public static void DrawWindowBackground(Rect rect)
		{
			GUI.color = Color.gray;
			GUI.DrawTexture(rect, BaseContent.WhiteTex);
			GUI.color = Color.gray;
			Widgets.DrawBox(rect, 1, null);
			GUI.color = Color.white;
		}
		public static void DrawWindowBackground1(Rect rect)
		{
			GUI.color = new Color(0.20f, 0.20f, 0.20f, 1f);
			GUI.DrawTexture(rect, BaseContent.WhiteTex);
			GUI.color = new Color(0.20f, 0.20f, 0.20f, 1f);
			Widgets.DrawBox(rect, 1, null);
			GUI.color = Color.white;
		}
	}
}
