﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Verse;
using RimWorld;
using UnityEngine;

namespace ChooseYourMedicine
{
	public class Dialog_Operations : Window
	{
		public override Vector2 InitialSize
		{
			get
			{
				return new Vector2(700f, 400f);
			}
		}

		public Dialog_Operations(MedicineEntryList list)
		{
			this.forcePause = true;
			this.doCloseX = true;
			this.doCloseButton = true;
			this.closeOnClickedOutside = true;
			this.absorbInputAroundWindow = true;
			this.doWindowBackground = true;
			this.drawShadow = false;
			this.focusWhenOpened = true; //what does this?
			this.list = list;
		}

		//The rect that gets used here is the InitialSize contractedBy(Margin). Margin should be 18f...
		public override void DoWindowContents(Rect inRect)
		{
			float tmpY = 0f;

			//Line for headline
			Text.Font = GameFont.Medium;
			Vector2 textVector = Text.CalcSize("Kopp_CYM_OperationsHeadline".Translate() + list.nameOfTheList);
			float textWidth = textVector.x;
			float textHeight = textVector.y;

			Rect headline = new Rect(InitialSize.x * 0.5f - 0.5f * textWidth, 0f, textWidth, textHeight);
			Widgets.Label(headline, "Kopp_CYM_OperationsHeadline".Translate() + list.nameOfTheList.Colorize(Color.yellow));
			tmpY += textHeight + 40f;

			Text.Font = GameFont.Small;


			//Line for dropdown menu
			Rect labelMaxAllowedMedicine = new Rect(0f, tmpY, InitialSize.x * 0.75f, 30f);
			Widgets.Label(labelMaxAllowedMedicine, "Kopp_CYM_OperationsMaxCare".Translate());
			Rect dropdownMaxAllowedMedicine = new Rect(0.9f * InitialSize.x - 30f, tmpY, 30f, 30f);
			if (StartUp.modMedicinePatchLoaded)
            {
				MedicalCareDropdownMenu_ModMedicinePatch.DynamicMedicalCareSelectButtonOperation(dropdownMaxAllowedMedicine, list);
			}
			else
            {
				MedicalCareDropdownMenu.MedicalCareSelectButtonOperation(dropdownMaxAllowedMedicine, list);
			}

			tmpY += 60f;


			//line for bool operationsSmartMedicineChoice, 
			Rect operationsSmartMedicineChoice  = new Rect(0f, tmpY, InitialSize.x * 0.9f, 30f);
			Widgets.CheckboxLabeled(operationsSmartMedicineChoice, "Kopp_CYM_OperationsWorseMed".Translate(), ref list.operationSmartMedicineChoice);
			//string tooltip = "Kopp_CYM_OperationsWorseMedTooltip".Translate();
			TooltipHandler.TipRegion(operationsSmartMedicineChoice, "Kopp_CYM_OperationsWorseMedTooltip".Translate());
			tmpY += 60f;

			//line for bool operationsOnlyWhenMaxChance
			Rect operationsOnlyWhenMaxChance = new Rect(0f, tmpY, InitialSize.x * 0.9f, 30f);
			Widgets.CheckboxLabeled(operationsOnlyWhenMaxChance, "Kopp_CYM_OperationsOnlyWhenBestSuccess".Translate(), ref list.operationsOnlyWhenMaxSuccessChance);
			//string tooltip2 = "Kopp_CYM_OperationsOnlyWhenBestSuccessTooltip".Translate();
			TooltipHandler.TipRegion(operationsOnlyWhenMaxChance, "Kopp_CYM_OperationsOnlyWhenBestSuccessTooltip".Translate());
			//tmpY += 60f;

		}

		public MedicineEntryList list;

	}

}