﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Verse;
using Verse.AI;
using HarmonyLib;
using RimWorld;

namespace ChooseYourMedicine
{
    //In vanilla when a tending gets started without medicine, the doc tends the whole patient without medicine
    //But if the doc is not drafted (so it is not a drafted tending), we want it to only tend one time, as we may have assigned "no medicine" to the first hediff that gets tended
    //and want the hediffs that come afterwards tended with the medicine we assigned.
    //So we remove the Jump toil if doc is not drafted and we dont use medicine
    //Not sure if there is a better/more compatible way to achieve this.

    class JobDriver_TendPatient_Postfix
    {
        public static void Postfix(ref IEnumerable<Toil> __result, JobDriver_TendPatient __instance, bool ___usesMedicine)
        {
            if (__instance.pawn != null && !__instance.pawn.Drafted && !___usesMedicine)
            {

                List<Toil> newList = __result.ToList();
                if (__result.Any())
                {
                    newList.RemoveAt(newList.Count() - 1); //removing the last item of the list ("Toils_Jump.Jump(gotoToil)")
                    __result = newList;
                }

            }
        }

    }
}
