﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using UnityEngine;
using HarmonyLib;

namespace ChooseYourMedicine
{
    public static class GetMedicineCountToFullyHeal_Prefix
    {
		//Why this prefix?
		//In vanilla the doctor counts how many medicine is needed to treat all hediffs and tries to bring that many
		//With the way vanilla works (just use the best medicine that is allowed for the patient) this is totally okay
		//But since we may want to tend hediffA with herbal, hediffB with industrial and hediffC with glitter the vanilla way does not work anymore
		//This prefix will fix the problem. It may happen that the doc runs from medicine stockpile to the patient and back a few times though...
        public static bool Prefix(Pawn pawn, ref int __result)
        {
			//a modified copy of vanilla
			int num = 0;
			int num2 = pawn.health.hediffSet.hediffs.Count + 1;
			tendableHediffsInTendPriorityOrder.Clear();
			List<Hediff> hediffs = pawn.health.hediffSet.hediffs;
			for (int i = 0; i < hediffs.Count; i++)
			{
				if (hediffs[i].TendableNow(false))
				{
					tendableHediffsInTendPriorityOrder.Add(hediffs[i]);
				}
			}
			TendUtility.SortByTendPriority(tendableHediffsInTendPriorityOrder);

			//now we have the hediff that gets tended first: tendableHediffsInTendPriorityOrder[0]
			//now we can figure out, which MedicalCareCategory is getting used (== which medicine)
			MedicalCareCategory medicalCare = Utility_GetList.GetTheCorrectMedicalCareCategory(pawn, tendableHediffsInTendPriorityOrder[0]);
			int num3 = 0;
			for (; ; )
			{
				num++;
				if (num > num2)
				{
					break;
				}
				TendUtility.GetOptimalHediffsToTendWithSingleTreatment(pawn, true, tmpHediffs, tendableHediffsInTendPriorityOrder);
				if (!tmpHediffs.Any<Hediff>())
				{
					goto IL_DF;
				}
				num3++;
				for (int j = 0; j < tmpHediffs.Count; j++)
				{
					tendableHediffsInTendPriorityOrder.Remove(tmpHediffs[j]);
				}
				//now we have the next hediff thats gets tended: tendableHediffsInTendPriorityOrder[0]
				//we can figure out the MedicalCareCategory... If it is the same as above, continue, if not, break.
				if (tendableHediffsInTendPriorityOrder.Any())
				{
					MedicalCareCategory medicalCare2 = Utility_GetList.GetTheCorrectMedicalCareCategory(pawn, tendableHediffsInTendPriorityOrder[0]);
					if (medicalCare2 != medicalCare)
					{
						goto IL_DF;
					}
				}
				//
			}
			Log.Error("Too many iterations.");
		IL_DF:
			tmpHediffs.Clear();
			tendableHediffsInTendPriorityOrder.Clear();
			__result = num3;
			return false;
		}

		public static List<Hediff> tendableHediffsInTendPriorityOrder = new List<Hediff>();
		public static List<Hediff> tmpHediffs = new List<Hediff>();
	}


}
