﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using UnityEngine;

namespace ChooseYourMedicine
{
    public class MedicalCareDropdownMenu
    {
		//Easy
		public static void MedicalCareSelectButtonEasy(Rect rect, MedicineEntry medicineEntry)
		{
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>
				(
				rect,
				medicineEntry,
				new Func<MedicineEntry, MedicalCareCategory>(MedicalCareSelectButton_GetMedicalCareEasy),
				new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(MedicalCareSelectButton_GenerateMenuEasy),
				null,
				StartUp.careTextures[(int)medicineEntry.careCategoryEasy],
				null,
				null, 
				null, 
				true
				);
		}

        public static MedicalCareCategory MedicalCareSelectButton_GetMedicalCareEasy(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryEasy;
		}

		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> MedicalCareSelectButton_GenerateMenuEasy(MedicineEntry medicineEntry)
		{
			int num;
			for (int i = 1; i < 5; i = num + 1)
			{
				MedicalCareCategory mc = (MedicalCareCategory)i;
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(mc.GetLabel(), delegate ()
					{
						medicineEntry.careCategoryEasy = mc;
					}, Utility_GetList.GetTexture(mc), Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = mc
				};
				num = i;
			}
			yield break;
		}

		//Standard
		public static void MedicalCareSelectButtonStandard(Rect rect, MedicineEntry medicineEntry)
		{
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>
				(
				rect,
				medicineEntry,
				new Func<MedicineEntry, MedicalCareCategory>(MedicalCareSelectButton_GetMedicalCareStandard),
				new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(MedicalCareSelectButton_GenerateMenuStandard),
				null,
				StartUp.careTextures[(int)medicineEntry.careCategoryStandard],
				null,
				null,
				null,
				true
				);
		}

		public static MedicalCareCategory MedicalCareSelectButton_GetMedicalCareStandard(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryStandard;
		}

		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> MedicalCareSelectButton_GenerateMenuStandard(MedicineEntry medicineEntry)
		{
			int num;
			for (int i = 1; i < 5; i = num + 1)
			{
				MedicalCareCategory mc = (MedicalCareCategory)i;
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(mc.GetLabel(), delegate ()
					{
						medicineEntry.careCategoryStandard = mc;
					}, Utility_GetList.GetTexture(mc), Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = mc
				};
				num = i;
			}
			yield break;
		}


		//Problematic
		public static void MedicalCareSelectButtonProblematic(Rect rect, MedicineEntry medicineEntry)
		{
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>
				(
				rect,
				medicineEntry,
				new Func<MedicineEntry, MedicalCareCategory>(MedicalCareSelectButton_GetMedicalCareProblematic),
				new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(MedicalCareSelectButton_GenerateMenuProblematic),
				null,
				StartUp.careTextures[(int)medicineEntry.careCategoryProblematic],
				null,
				null,
				null,
				true
				);
		}

		public static MedicalCareCategory MedicalCareSelectButton_GetMedicalCareProblematic(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryProblematic;
		}

		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> MedicalCareSelectButton_GenerateMenuProblematic(MedicineEntry medicineEntry)
		{
			int num;
			for (int i = 1; i < 5; i = num + 1)
			{
				MedicalCareCategory mc = (MedicalCareCategory)i;
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(mc.GetLabel(), delegate ()
					{
						medicineEntry.careCategoryProblematic = mc;
					}, Utility_GetList.GetTexture(mc), Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = mc
				};
				num = i;
			}
			yield break;
		}

		//Immunity lower than
		public static void MedicalCareSelectButtonImmunityLower(Rect rect, MedicineEntry medicineEntry)
		{
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>
				(
				rect,
				medicineEntry,
				new Func<MedicineEntry, MedicalCareCategory>(MedicalCareSelectButton_GetMedicalCareImmunityLower),
				new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(MedicalCareSelectButton_GenerateMenuImmunityLower),
				null,
				StartUp.careTextures[(int)medicineEntry.careCategoryImmunityLower],
				null,
				null,
				null,
				true
				);
		}

		public static MedicalCareCategory MedicalCareSelectButton_GetMedicalCareImmunityLower(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryImmunityLower;
		}

		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> MedicalCareSelectButton_GenerateMenuImmunityLower(MedicineEntry medicineEntry)
		{
			int num;
			for (int i = 1; i < 5; i = num + 1)
			{
				MedicalCareCategory mc = (MedicalCareCategory)i;
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(mc.GetLabel(), delegate ()
					{
						medicineEntry.careCategoryImmunityLower = mc;
					}, Utility_GetList.GetTexture(mc), Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = mc
				};
				num = i;
			}
			yield break;
		}



		public static void MedicalCareSelectButtonOperation(Rect rect, MedicineEntryList list)
		{
			Widgets.Dropdown<MedicineEntryList, MedicalCareCategory>
				(
				rect,
				list,
				new Func<MedicineEntryList, MedicalCareCategory>(MedicalCareSelectButton_GetMedicalCareOperation),
				new Func<MedicineEntryList, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(MedicalCareSelectButton_GenerateMenuOperation),
				null,
				StartUp.careTextures[(int)list.operationsMaxAllowedMedCare],
				//null,
				//
				null,
				null,
				null,
				true
				);
		}

		public static MedicalCareCategory MedicalCareSelectButton_GetMedicalCareOperation(MedicineEntryList list)
		{

			return list.operationsMaxAllowedMedCare;
			//return MedicalCareCategory.Best;
		}

		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> MedicalCareSelectButton_GenerateMenuOperation(MedicineEntryList list)
		{
			int num;
			for (int i = 0; i < 5; i = num + 1)
			{
				MedicalCareCategory mc = (MedicalCareCategory)i;
				//no medical care / no medicine does not make sense for operations
				if (mc <= MedicalCareCategory.NoMeds)
				{
					num = i;
					continue;
				}
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(mc.GetLabel(), delegate ()
					{
						list.operationsMaxAllowedMedCare = mc;
					}, Utility_GetList.GetTexture(mc), Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = mc
				};
				num = i;
			}
			yield break;
		}

	}
}
