﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;

namespace ChooseYourMedicine
{
    public class MedicineEntry: IExposable
    {
        public MedicineEntry()
        {
        }

        public MedicineEntry(MedicineEntry oldEntry)
        {
            this.label = oldEntry.label;
            this.defName = oldEntry.defName;
            this.careCategoryEasy = oldEntry.careCategoryEasy;
            this.careCategoryStandard = oldEntry.careCategoryStandard;
            this.careCategoryProblematic = oldEntry.careCategoryProblematic;
            this.careCategoryImmunityLower = oldEntry.careCategoryImmunityLower;
            this.offSetEasy = oldEntry.offSetEasy;
            this.offSetProblematic = oldEntry.offSetProblematic;
            this.offSetImmunityLower = oldEntry.offSetImmunityLower;
            this.shouldBeHidden = oldEntry.shouldBeHidden;
            this.hasCompImmunizable = oldEntry.hasCompImmunizable;
        }

        public virtual void ExposeData()
        {
            Scribe_Values.Look<string>(ref this.label, "label");
            Scribe_Values.Look<string>(ref this.defName, "defName");
            Scribe_Values.Look<MedicalCareCategory>(ref this.careCategoryEasy, "careCategoryEasy");
            Scribe_Values.Look<MedicalCareCategory>(ref this.careCategoryStandard, "careCategoryStandard");
            Scribe_Values.Look<MedicalCareCategory>(ref this.careCategoryProblematic, "careCategoryProblematic");
            Scribe_Values.Look<MedicalCareCategory>(ref this.careCategoryImmunityLower, "careCategoryImmunityLower");
            Scribe_Values.Look<int>(ref this.offSetEasy, "offSetEasy");
            Scribe_Values.Look<int>(ref this.offSetProblematic, "offSetProblematic");
            Scribe_Values.Look<int>(ref this.offSetImmunityLower, "offSetImmunityLower");
            Scribe_Values.Look<bool>(ref this.shouldBeHidden, "shouldBeHidden");
            Scribe_Values.Look<bool>(ref this.hasCompImmunizable, "hasCompImmunizable");

        }

        public string label;
        public string defName;
        public MedicalCareCategory careCategoryEasy;
        public MedicalCareCategory careCategoryStandard;
        public MedicalCareCategory careCategoryProblematic;
        public MedicalCareCategory careCategoryImmunityLower;
        public int offSetEasy;
        public int offSetProblematic;
        public int offSetImmunityLower;
        public bool shouldBeHidden;
        public bool hasCompImmunizable;

    }
}
