﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using UnityEngine;

namespace ChooseYourMedicine
{
    public class MedicineEntryList : IExposable
    {
		public MedicineEntryList()
		{
		}

		public MedicineEntryList(MedicineEntryList oldList)
		{
			this.nameOfTheList = oldList.nameOfTheList;
			this.list = new List<MedicineEntry>();
			for (int i = 0; i < oldList.list.Count(); i++)
			{
				this.list.Add(new MedicineEntry(oldList.list[i]));
			}
			this.operationsMaxAllowedMedCare = oldList.operationsMaxAllowedMedCare;
			this.operationSmartMedicineChoice = oldList.operationSmartMedicineChoice;
			this.operationsOnlyWhenMaxSuccessChance = oldList.operationsOnlyWhenMaxSuccessChance;
		}

		public virtual void ExposeData()
		{
			Scribe_Values.Look<string>(ref this.nameOfTheList, "nameOfTheList");
			Scribe_Collections.Look<MedicineEntry>(ref list, "list", LookMode.Deep);
			Scribe_Values.Look<MedicalCareCategory>(ref this.operationsMaxAllowedMedCare, "operationsMaxAllowedMedCare");
			Scribe_Values.Look<bool>(ref this.operationSmartMedicineChoice, "operationSmartMedicineChoice");
			Scribe_Values.Look<bool>(ref this.operationsOnlyWhenMaxSuccessChance, "operationsOnlyWhenMaxSuccessChance");
		}

		public string nameOfTheList;
		public List<MedicineEntry> list = new List<MedicineEntry>();
		public MedicalCareCategory operationsMaxAllowedMedCare;
		public bool operationSmartMedicineChoice;
		public bool operationsOnlyWhenMaxSuccessChance;

	}
}
