﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using HarmonyLib;
using System.Reflection.Emit;
using UnityEngine;

namespace ChooseYourMedicine
{
    class DrawHediffRow_Transpiler
    {
        //Credits to legodude?: A transpiler in Vanilla Factions Expanded - Ancients was a really helpful example

        //DrawHediffRowTranspiler
        //first if statement:
        //we want to render a button which then opens a drowdown menu when clicked for every tendable hediff(group) in a pawns health tab
        /* original code and where we want our stuff:
            foreach (IGrouping<int, Hediff> source in from x in diffs
			group x by x.UIGroupKey)
			{
				int num4 = source.Count<Hediff>();
				string text = source.First<Hediff>().LabelCap;
				if (num4 != 1)
				{
					text = text + " x" + num4.ToString();
				}

                    ********************************************************
                    ******** <-- here we want to insert our stuff ********
                    ********************************************************

				num3 += Text.CalcHeight(text, width);
			}
			b = num3;
			HealthCardUtility.DoRightRowHighlight(new Rect(0f, curY, rect.width, Mathf.Max(a, b)));

         */

        //second if statement:
        //It somehow happens that "Text.CalcHeight(text, width);" gives back different values (text needs 1 line, text needs 2 lines) for the exact same text and width.
        //This leaded to the button to assign med manually was rendered correctly, but you had to click below it to open the dropdown menu.
        //It was reproducible with "cryptosleep sickness (xhours)" and dev mode off. (Using dev quick test in main menu).
        //It took me quite a few hours to trace down what is happening, but rounding the width seems to fix the issue... I dont know why exactly this is happening... 

        public static IEnumerable<CodeInstruction> DrawHediffRowTranspiler(IEnumerable<CodeInstruction> codeInstructions)
        {
            var codes = codeInstructions.ToList();
            var concat = AccessTools.Method(typeof(String), "Concat", new Type[] { typeof(string), typeof(string), typeof(string) });
            bool foundLineNewButton = false;
            bool foundLineRoundWidth = false;
            for (var i = 0; i < codes.Count; i++)
            {
                var code = codes[i];
                yield return code;

                //if (i == 76) 
                if (foundLineNewButton == false && i > 50 && i < 100 && codes[i-5].opcode == OpCodes.Ldstr && codes[i-2].Calls(concat))
                {
                    yield return new CodeInstruction(OpCodes.Ldarg_0);
                    yield return new CodeInstruction(OpCodes.Ldarg_1);
                    yield return new CodeInstruction(OpCodes.Ldarg_3);
                    yield return new CodeInstruction(OpCodes.Ldloc_S, 7);
                    yield return new CodeInstruction(OpCodes.Callvirt, AccessTools.Method(typeof(IEnumerator<Hediff>), "get_Current"));
                    yield return new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(DrawHediffRow_Transpiler), nameof(Transpiler)));
                    yield return new CodeInstruction(OpCodes.Ldloc_S, 6); //We put this at the end because we use the one from the CalcHeight method. If we start the transpiler 1 line earlier, 
                    //we are still in the if-statement... 
                    foundLineNewButton = true;
                }

                //round local var 'width'
                if (foundLineRoundWidth == false && i > 10 && codes[i + 1].opcode == OpCodes.Stloc_2)
                {
                    yield return new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(DrawHediffRow_Transpiler), nameof(RoundWidth)));
                    foundLineRoundWidth = true;
                }
            }
        }

        public static float RoundWidth(float width)
        {
            return Mathf.RoundToInt(width);
        }


        public static void Transpiler(float num6, Rect rect, Pawn pawn, ref float curY, IGrouping<BodyPartRecord, Hediff> groupPartHediff)
        {
            Hediff hediff = groupPartHediff.First();
            if (!DrawButton.RenderButton(pawn, hediff))
            {
                return;
            }          

            float xPos = (DebugSettings.ShowDevGizmos && Current.ProgramState == ProgramState.Playing) ? 90f : 66f;
            Rect buttonAssignMedicineManually = new Rect(rect.width - xPos, curY + num6 + 3f, 16f, 16f);

            DrawButton.DrawButtonToAssignMedManually(buttonAssignMedicineManually, pawn, groupPartHediff.ToList(), hediff);
        }


    }   
}
