﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Verse;
using RimWorld;
using RimWorld.Planet;

namespace ChooseYourMedicine
{
	//This patch is necessary that pawns on caravans are affected by the settings in the gui/pawns health tab as well.
	public class TryGetBestMedicine_Prefix
	{
		public static bool Prefix(Caravan caravan, Pawn patient, out Medicine medicine, out Pawn owner, bool __result)
		{
			//The medicine we would like to use for that hediff/for that tending
			MedicalCareCategory medicalCare = Utility_GetList.GetTheCorrectMedicalCareCategory(patient);

			int idx = 0;
			if (StartUp.modMedicinePatchLoaded)
            {
				Compatibility_ModMedicinePatch.GetIndexFromMedicalCare(medicalCare, ref idx);
            }

			//check if medicine is even necessary
			if (medicalCare <= MedicalCareCategory.NoMeds || Medicine.GetMedicineCountToFullyHeal(patient) <= 0)
			{
				medicine = null;
				owner = null;
				__result = false;
				return false;
			}

			//all available medicine that caravan has
			IEnumerable<Thing> list = CaravanInventoryUtility.AllInventoryItems(caravan).Where(x => x.def.IsMedicine);

			//looping and lowering medicalCare until "noMeds" or we found a fitting medicine
			for (; ; )
			{
				foreach (Thing potentialMedicine in list)
				{
					//if modMedicinePatch is loaded
					if (StartUp.modMedicinePatchLoaded)
					{
						if (Compatibility_ModMedicinePatch.CheckIfMedicineFitsCareCategory(potentialMedicine, idx))
                        {
							medicine = (Medicine)potentialMedicine;
							owner = CaravanInventoryUtility.GetOwnerOf(caravan, potentialMedicine);
							__result = true;
							return false;
						}
					}
					//if modMedicinePatch is not loaded
					else
					{
						if (GetMedicalCare.GetMedicalCareCategory(potentialMedicine) == medicalCare)
						{
							medicine = (Medicine)potentialMedicine;
							owner = CaravanInventoryUtility.GetOwnerOf(caravan, potentialMedicine);
							__result = true;
							return false;
						}
					}

				}
				medicalCare--;
				if (medicalCare <= MedicalCareCategory.NoMeds)
				{
					medicine = null;
					owner = null;
					__result = false;
					return false;
				}
			}
		}
	}
}
