﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Verse;
using RimWorld;
//using ModMedicinePatch;
using UnityEngine;

namespace ChooseYourMedicine
{
    public class MedicalCareDropdownMenu_ModMedicinePatch
    {
		//This is a copy of 'Mod Medicine Patch'

		//Easy
		public static void DynamicMedicalCareSelectButtonEasy(Rect rect, MedicineEntry medicineEntry)
		{
			Func<MedicineEntry, MedicalCareCategory> getPayload = new Func<MedicineEntry, MedicalCareCategory>(DynGetMedicalCare__GetMedicalCareEasy);
			Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>> menuGenerator = new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(DynMedGenerateMenuEasy);
			Texture2D buttonIcon = TraverseStuff.method_modMedicinePatch_GetCareTexture.GetValue<Texture2D>(medicineEntry.careCategoryEasy);
			//if (ModMedicinePatch.androids)
			//{
			//	buttonIcon = ModMedicinePatch.FindBestAndroidCompatMedicine(pawn).tex;
			//}
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>(rect, medicineEntry, getPayload, menuGenerator, null, buttonIcon, null, null, null, true);
		}

		public static MedicalCareCategory DynGetMedicalCare__GetMedicalCareEasy(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryEasy;
		}


		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> DynMedGenerateMenuEasy(MedicineEntry medicineEntry)
		{
			List<ModMedicineCopy> localMedList = TraverseStuff.modMedicineList;
			//if (ModMedicinePatch.androids)
			//{
			//	localMedList = ModMedicinePatch.GetAndroidCompatMedList(p);
			//}
			int num;
			for (int i = 0; i < localMedList.Count; i = num + 1)
			{
				ModMedicineCopy med = localMedList[i];
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(med.care.GetLabel().CapitalizeFirst(), delegate ()
					{
						medicineEntry.careCategoryEasy = med.care;
					}, med.tex, Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = med.care
				};
				num = i;
			}
			yield break;
		}


		//Standard
		public static void DynamicMedicalCareSelectButtonStandard(Rect rect, MedicineEntry medicineEntry)
		{
			Func<MedicineEntry, MedicalCareCategory> getPayload = new Func<MedicineEntry, MedicalCareCategory>(DynGetMedicalCare__GetMedicalCareStandard);
			Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>> menuGenerator = new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(DynMedGenerateMenuStandard);
			Texture2D buttonIcon = TraverseStuff.method_modMedicinePatch_GetCareTexture.GetValue<Texture2D>(medicineEntry.careCategoryStandard);
			//if (ModMedicinePatch.androids)
			//{
			//	buttonIcon = ModMedicinePatch.FindBestAndroidCompatMedicine(pawn).tex;
			//}
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>(rect, medicineEntry, getPayload, menuGenerator, null, buttonIcon, null, null, null, true);
		}

		public static MedicalCareCategory DynGetMedicalCare__GetMedicalCareStandard(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryStandard;
		}


		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> DynMedGenerateMenuStandard(MedicineEntry medicineEntry)
		{
			List<ModMedicineCopy> localMedList = TraverseStuff.modMedicineList;
			//if (ModMedicinePatch.androids)
			//{
			//	localMedList = ModMedicinePatch.GetAndroidCompatMedList(p);
			//}
			int num;
			for (int i = 0; i < localMedList.Count; i = num + 1)
			{
				ModMedicineCopy med = localMedList[i];
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(med.care.GetLabel().CapitalizeFirst(), delegate ()
					{
						medicineEntry.careCategoryStandard = med.care;
					}, med.tex, Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = med.care
				};
				num = i;
			}
			yield break;
		}


		//Problematic
		public static void DynamicMedicalCareSelectButtonProblematic(Rect rect, MedicineEntry medicineEntry)
		{
			Func<MedicineEntry, MedicalCareCategory> getPayload = new Func<MedicineEntry, MedicalCareCategory>(DynGetMedicalCare__GetMedicalCareProblematic);
			Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>> menuGenerator = new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(DynMedGenerateMenuProblematic);
			Texture2D buttonIcon = TraverseStuff.method_modMedicinePatch_GetCareTexture.GetValue<Texture2D>(medicineEntry.careCategoryProblematic);
			//if (ModMedicinePatch.androids)
			//{
			//	buttonIcon = ModMedicinePatch.FindBestAndroidCompatMedicine(pawn).tex;
			//}
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>(rect, medicineEntry, getPayload, menuGenerator, null, buttonIcon, null, null, null, true);
		}

		public static MedicalCareCategory DynGetMedicalCare__GetMedicalCareProblematic(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryProblematic;
		}


		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> DynMedGenerateMenuProblematic(MedicineEntry medicineEntry)
		{
			List<ModMedicineCopy> localMedList = TraverseStuff.modMedicineList;
			//if (ModMedicinePatch.androids)
			//{
			//	localMedList = ModMedicinePatch.GetAndroidCompatMedList(p);
			//}
			int num;
			for (int i = 0; i < localMedList.Count; i = num + 1)
			{
				ModMedicineCopy med = localMedList[i];
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(med.care.GetLabel().CapitalizeFirst(), delegate ()
					{
						medicineEntry.careCategoryProblematic = med.care;
					}, med.tex, Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = med.care
				};
				num = i;
			}
			yield break;
		}

		//Immunity lower than
		public static void DynamicMedicalCareSelectButtonImmunityLower(Rect rect, MedicineEntry medicineEntry)
		{
			Func<MedicineEntry, MedicalCareCategory> getPayload = new Func<MedicineEntry, MedicalCareCategory>(DynGetMedicalCare__GetMedicalCareImmunityLower);
			Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>> menuGenerator = new Func<MedicineEntry, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(DynMedGenerateMenuImmunityLower);
			Texture2D buttonIcon = TraverseStuff.method_modMedicinePatch_GetCareTexture.GetValue<Texture2D>(medicineEntry.careCategoryImmunityLower);
			//if (ModMedicinePatch.androids)
			//{
			//	buttonIcon = ModMedicinePatch.FindBestAndroidCompatMedicine(pawn).tex;
			//}
			Widgets.Dropdown<MedicineEntry, MedicalCareCategory>(rect, medicineEntry, getPayload, menuGenerator, null, buttonIcon, null, null, null, true);
		}

		public static MedicalCareCategory DynGetMedicalCare__GetMedicalCareImmunityLower(MedicineEntry medicineEntry)
		{
			return medicineEntry.careCategoryImmunityLower;
		}


		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> DynMedGenerateMenuImmunityLower(MedicineEntry medicineEntry)
		{
			List<ModMedicineCopy> localMedList = TraverseStuff.modMedicineList;
			//if (ModMedicinePatch.androids)
			//{
			//	localMedList = ModMedicinePatch.GetAndroidCompatMedList(p);
			//}
			int num;
			for (int i = 0; i < localMedList.Count; i = num + 1)
			{
				ModMedicineCopy med = localMedList[i];
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(med.care.GetLabel().CapitalizeFirst(), delegate ()
					{
						medicineEntry.careCategoryImmunityLower = med.care;
					}, med.tex, Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = med.care
				};
				num = i;
			}
			yield break;
		}


		//Operations
		public static void DynamicMedicalCareSelectButtonOperation(Rect rect, MedicineEntryList list)
		{
			Func<MedicineEntryList, MedicalCareCategory> getPayload = new Func<MedicineEntryList, MedicalCareCategory>(DynGetMedicalCare__GetMedicalCareOperation);
			Func<MedicineEntryList, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>> menuGenerator = new Func<MedicineEntryList, IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>>>(DynMedGenerateMenuOperation);
			Texture2D buttonIcon = TraverseStuff.method_modMedicinePatch_GetCareTexture.GetValue<Texture2D>(list.operationsMaxAllowedMedCare);
			//if (ModMedicinePatch.androids)
			//{
			//	buttonIcon = ModMedicinePatch.FindBestAndroidCompatMedicine(pawn).tex;
			//}
			Widgets.Dropdown<MedicineEntryList, MedicalCareCategory>(rect, list, getPayload, menuGenerator, null, buttonIcon, null, null, null, true);
		}

		public static MedicalCareCategory DynGetMedicalCare__GetMedicalCareOperation(MedicineEntryList list)
		{
			return list.operationsMaxAllowedMedCare;
		}


		public static IEnumerable<Widgets.DropdownMenuElement<MedicalCareCategory>> DynMedGenerateMenuOperation(MedicineEntryList list)
		{
			List<ModMedicineCopy> localMedList = TraverseStuff.modMedicineList;
			//if (ModMedicinePatch.androids)
			//{
			//	localMedList = ModMedicinePatch.GetAndroidCompatMedList(p);
			//}
			int num;
			for (int i = 0; i < localMedList.Count; i = num + 1)
			{
				ModMedicineCopy med = localMedList[i];
				//No medical care / No medicine for operations does not make sense
				if (med.care <= MedicalCareCategory.NoMeds)
				{
					num = i;
					continue;
				}
				yield return new Widgets.DropdownMenuElement<MedicalCareCategory>
				{
					option = new FloatMenuOption(med.care.GetLabel().CapitalizeFirst(), delegate ()
					{
						list.operationsMaxAllowedMedCare = med.care;
					}, med.tex, Color.white, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0),
					payload = med.care
				};
				num = i;
			}
			yield break;
		}
	}
}
