﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using UnityEngine;

namespace ChooseYourMedicine
{
	public class MainTabWindow_Medicine_HelperGui : Window
	{
		public override Vector2 InitialSize
		{
			get
			{
                return new Vector2(UI.screenWidth, UI.screenHeight);
			}
		}

		public MainTabWindow_Medicine_HelperGui()
		{
			this.forcePause = true;
			this.doCloseX = true;
			this.doCloseButton = true;
			this.closeOnClickedOutside = true;
			this.absorbInputAroundWindow = true;
			this.doWindowBackground = false;
			this.drawShadow = false;
			this.focusWhenOpened = false;
		}

		//The rect that gets used here is the rect/Vector2 we defined earlier contractedBy(Margin). Margin should be 18f...
		public override void DoWindowContents(Rect inRect)
		{
			Text.Font = GameFont.Small;
			Color darkGray = MainTabWindow_Medicine_HelperGui.darkGray;

			if (UI.screenWidth < 1920)
			{
				Text.Font = GameFont.Tiny;
			}

			//if we open the mods gui from the mod settings and open the helper, we need to adjust its position
			if (needToApplyOffsets == true && Find.WindowStack.Windows.Where(x => x.GetType() == typeof(Dialog_ModSettings)).Any())
			{
				float xOffset = (UI.screenWidth - 1540f) * 0.5f;

				firstVerticalLine += xOffset;
				secondVerticalLine += xOffset;
				thirdVerticalLine += xOffset;
				fourthVerticalLine += xOffset;
				//fifthVerticalLine += xOffset;
				oneThreeFiveNull += xOffset;
				horizontalCenter += xOffset;


                float yOffset = (UI.screenHeight - 834f) * 0.5f;
                windowRect.y = -yOffset;
				heightOne += 20f;
				//heightTwo +=;
				heightThree += 20f;
				heightFour += 20f;
				heightFive += 20f;
				heightSix += 20f;


				needToApplyOffsets = false;
			}
			else
            {
				needToApplyOffsets = false;
            }


			//	## TEXT BOXES ## 

			//How the mod decides which medicine is used
			//Manually assign medicine
			string textBox1 = "Kopp_CYM_HelperWhichMedicine1".Translate();
			Rect rect1 = new Rect(horizontalCenter - 0.5f * width3, heightOne, width3, Text.CalcHeight(textBox1, width3 - 2 * contractBy) + 2 * contractBy);
			Rect rect1_1 = new Rect(rect1).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect1, darkGray, Color.white);
			Widgets.Label(rect1_1, textBox1);

			//Immunity lower
			string textBox2 = "Kopp_CYM_HelperWhichMedicine2".Translate();
			Rect rect2 = new Rect(fourthVerticalLine, heightThree, width1, Text.CalcHeight(textBox2, width1 - 2 * contractBy) + 2 * contractBy);
			Rect rect2_1 = new Rect(rect2).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect2, darkGray, Color.white);
			Widgets.Label(rect2_1, textBox2);

			//Problematic
			string textBox3 = "Kopp_CYM_HelperWhichMedicine3".Translate();
			Rect rect3 = new Rect(thirdVerticalLine, heightFour, width2, Text.CalcHeight(textBox3, width2 - 2 * contractBy) + 2 * contractBy);
			Rect rect3_1 = new Rect(rect3).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect3, darkGray, Color.white);
			Widgets.Label(rect3_1, textBox3);

			//Easy
			string textBox4 = "Kopp_CYM_HelperWhichMedicine4".Translate();
			Rect rect4 = new Rect(firstVerticalLine, heightFive, width1, Text.CalcHeight(textBox4, width1 - 2 * contractBy) + 2 * contractBy);
			Rect rect4_1 = new Rect(rect4).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect4, darkGray, Color.white);
			Widgets.Label(rect4_1, textBox4);

			//Standard
			string textBox5 = "Kopp_CYM_HelperWhichMedicine5".Translate();
			Rect rect5 = new Rect(secondVerticalLine, heightSix, width2, Text.CalcHeight(textBox5, width2 - 2 * contractBy) + 2 * contractBy);
			Rect rect5_1 = new Rect(rect5).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect5, darkGray, Color.white);
			Widgets.Label(rect5_1, textBox5);


			//Others
			//CopyPasteButtons
			string textBox6 = "Kopp_CYM_HelperCopyPaste".Translate();
			Rect rect6 = new Rect(oneThreeFiveNull, heightOne, width1, Text.CalcHeight(textBox6, width1 - 2 * contractBy) + 2 * contractBy);
			Rect rect6_1 = new Rect(rect6).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect6, Color.gray, Color.white);
			Widgets.Label(rect6_1, textBox6);

			//TopLeftButtons
            string textBox7 = "Kopp_CYM_HelperLeftButtons".Translate();
            Rect rect7 = new Rect(0f, heightOne, width1, Text.CalcHeight(textBox7, width1 - 2 * contractBy) + 2 * contractBy);
			Rect rect7_1 = new Rect(rect7).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect7, Color.gray, Color.white);
			Widgets.Label(rect7_1, textBox7);

			//Labels
			string textBox8 = "Kopp_CYM_HelperLabels".Translate();
			Rect rect8 = new Rect(0f, heightFour, width4, Text.CalcHeight(textBox8, width4 - 2 * contractBy) + 2 * contractBy);
			Rect rect8_1 = new Rect(rect8).ContractedBy(contractBy);
			Widgets.DrawBoxSolidWithOutline(rect8, Color.gray, Color.white);
			Widgets.Label(rect8_1, textBox8);
		}



		public static Color darkGray = new Color(0.20f, 0.20f, 0.20f, 1f);
		public bool needToApplyOffsets = true;

		//x values
		float firstVerticalLine = 211f;
		float secondVerticalLine = 489f;
		float thirdVerticalLine = 766f;
		float fourthVerticalLine = 1043f;
		//float fifthVerticalLine = 1321f;
		float oneThreeFiveNull = 1350f;

		float horizontalCenter = 770f;
		float width1 = 278f;
		float width2 = 277f;
		float width3 = 428f;
		float width4 = 212f;

		//y values
		float heightOne = 150f;
		//float heightTwo = 220f;
		float heightThree = 380f;
		float heightFour = 520f;
		float heightFive = 700f;
		float heightSix = 860f;

		//x/y
		float contractBy = 10f;
	}
}
