﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using Verse.AI;
using HarmonyLib;
using System.Reflection;
using System.Reflection.Emit;

namespace ChooseYourMedicine
{
    //Thanks to Roolo at https://ludeon.com/forums/index.php?topic=29517.225
    //The TargetMethod is a slightly modified copy
    [HarmonyPatch]
    class MakeNewToil_Transpiler
    {

        //When we assign a medicine manually to a hediff which is "better" than what the pawns settings allow, we get a 10 jobs in 10 ticks problem... This should fix it.

        //target (what is written at the end of the method in IL code): end of method '<>c__DisplayClass17_0'::'<MakeNewToils>b__0'

        //code we want to nop: JobDriver_TendPatient.MakeNewToils: !this.Deliveree.playerSettings.medCare.AllowsMedicine(this.MedicineUsed.def))

        /*
             
             IL_002A: call instance class Verse.Pawn RimWorld.JobDriver_TendPatient::get_Deliveree()
             IL_002F: ldfld class RimWorld.Pawn_PlayerSettings Verse.Pawn::playerSettings
             IL_0034: brfalse.s IL_0064
             
            ######  FROM HERE ######
             IL_0036: ldarg.0
             IL_0037: ldfld     class RimWorld.JobDriver_TendPatient RimWorld.JobDriver_TendPatient/'<>c__DisplayClass17_0'::'<>4__this'
             IL_003C: call instance class Verse.Pawn RimWorld.JobDriver_TendPatient::get_Deliveree()
             IL_0041: ldfld class RimWorld.Pawn_PlayerSettings Verse.Pawn::playerSettings
             IL_0046: ldfld valuetype RimWorld.MedicalCareCategory RimWorld.Pawn_PlayerSettings::medCare
             IL_004B: ldarg.0
             IL_004C: ldfld     class RimWorld.JobDriver_TendPatient RimWorld.JobDriver_TendPatient/'<>c__DisplayClass17_0'::'<>4__this'
             IL_0051: call instance class Verse.Thing RimWorld.JobDriver_TendPatient::get_MedicineUsed()
             IL_0056: ldfld class Verse.ThingDef Verse.Thing::def
             IL_005B: call      bool RimWorld.MedicalCareUtility::AllowsMedicine(valuetype RimWorld.MedicalCareCategory, class Verse.ThingDef)
             IL_0060: brtrue.s IL_0064

             IL_0062: ldc.i4.1
             IL_0063: ret
         ######  TO HERE ######

             IL_0064: ldarg.0
             IL_0065: ldfld class RimWorld.JobDriver_TendPatient RimWorld.JobDriver_TendPatient/'<>c__DisplayClass17_0'::'<>4__this'
             IL_006A: ldfld     class Verse.Pawn Verse.AI.JobDriver::pawn

            */


        static MethodBase TargetMethod()
        {
            var predicateClass = typeof(JobDriver_TendPatient).GetNestedTypes(AccessTools.all)
                .FirstOrDefault(t => t.FullName.Contains("17_0"));
            return predicateClass.GetMethods(AccessTools.all).FirstOrDefault(m => m.ReturnType == typeof(bool));

        }

        public static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var codes = new List<CodeInstruction>(instructions);
            for (var i = 0; i < codes.Count; i++)
            {
                if (i > 10 && codes[i].opcode == OpCodes.Ldarg_0 && codes[i - 1].opcode == OpCodes.Brfalse_S && codes[i + 10].opcode == OpCodes.Brtrue_S)
                {
                    for (var j = 0; j < 13; j++)
                    {
                        codes[i + j].opcode = OpCodes.Nop;
                    }
                    break;
                }
            }
            return codes.AsEnumerable();
        }
    }
}
