﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using UnityEngine;
using Verse.Sound;

namespace ChooseYourMedicine
{
	//This is a straight copy of vanilla.
	//Only one little change in TTabRecord DrawTabs so that the selected tab has a different text color.
	public static class Utility_VanillaCopy_TabDrawer
	{
		public static TabRecord DrawTabs(Rect baseRect, List<TabRecord> tabs, int rows)
		{
			if (rows <= 1)
			{
				return Utility_VanillaCopy_TabDrawer.DrawTabs<TabRecord>(baseRect, tabs, 200f);
			}
			int num = Mathf.FloorToInt((float)(tabs.Count / rows));
			int num2 = 0;
			TabRecord result = null;
			Rect rect = baseRect;
			baseRect.yMin -= (float)(rows - 1) * 31f;
			Rect rect2 = baseRect;
			rect2.yMax = rect.y;
			Widgets.DrawMenuSection(rect2);
			for (int i = 0; i < rows; i++)
			{
				int num3 = (i == 0) ? (tabs.Count - (rows - 1) * num) : num;
				Utility_VanillaCopy_TabDrawer.tmpTabs.Clear();
				for (int j = num2; j < num2 + num3; j++)
				{
					Utility_VanillaCopy_TabDrawer.tmpTabs.Add(tabs[j]);
				}
				TabRecord tabRecord = Utility_VanillaCopy_TabDrawer.DrawTabs<TabRecord>(baseRect, Utility_VanillaCopy_TabDrawer.tmpTabs, baseRect.width);
				if (tabRecord != null)
				{
					result = tabRecord;
				}
				baseRect.yMin += 31f;
				num2 += num3;
			}
			Utility_VanillaCopy_TabDrawer.tmpTabs.Clear();
			return result;
		}

		public static TTabRecord DrawTabs<TTabRecord>(Rect baseRect, List<TTabRecord> tabs, float maxTabWidth = 200f) where TTabRecord : TabRecord
		{
			TTabRecord ttabRecord = default(TTabRecord);
			TTabRecord ttabRecord2 = tabs.Find((TTabRecord t) => t.Selected);
			//
			if (ttabRecord2 != null)
			{
				ttabRecord2.labelColor = Color.yellow;
			}
			//

			float num = baseRect.width + (float)(tabs.Count - 1) * 10f;
			float tabWidth = num / (float)tabs.Count;
			if (tabWidth > maxTabWidth)
			{
				tabWidth = maxTabWidth;
			}
			Rect position = new Rect(baseRect);
			position.y -= 32f;
			position.height = 9999f;
			GUI.BeginGroup(position);
			Text.Anchor = TextAnchor.MiddleCenter;
			Text.Font = GameFont.Small;
			Func<TTabRecord, Rect> func = (TTabRecord tab) => new Rect((float)tabs.IndexOf(tab) * (tabWidth - 10f), 1f, tabWidth, 41f); //32f to 50f
			List<TTabRecord> list = tabs.ListFullCopy<TTabRecord>();
			// We want a tooltip if we hover over "imprisoned colonists" tab
			Rect imprisonedColonists = func(tabs[1]);
			if (tabs[1] != null && Mouse.IsOver(imprisonedColonists))
			{
				TooltipHandler.TipRegion(imprisonedColonists, "Kopp_CYM_ImprisonedColonistsTooltip".Translate());
			}
			//
			if (ttabRecord2 != null)
			{
				list.Remove(ttabRecord2);
				list.Add(ttabRecord2);
			}
			TabRecord tabRecord = null;
			List<TTabRecord> list2 = list.ListFullCopy<TTabRecord>();
			list2.Reverse();
			for (int i = 0; i < list2.Count; i++)
			{
				TTabRecord ttabRecord3 = list2[i];
				Rect rect = func(ttabRecord3);
				if (tabRecord == null && Mouse.IsOver(rect))
				{
					tabRecord = ttabRecord3;
				}
				MouseoverSounds.DoRegion(rect, SoundDefOf.Mouseover_Tab);
				if (Widgets.ButtonInvisible(rect, true))
				{
					ttabRecord = ttabRecord3;
				}
			}
			foreach (TTabRecord ttabRecord4 in list)
			{
				Rect rect2 = func(ttabRecord4);
				ttabRecord4.Draw(rect2);
			}
			Text.Anchor = TextAnchor.UpperLeft;
			GUI.EndGroup();
			if (ttabRecord != null && ttabRecord != ttabRecord2)
			{
				SoundDefOf.RowTabSelect.PlayOneShotOnCamera(null);
				if (ttabRecord.clickedAction != null)
				{
					ttabRecord.clickedAction();
					MainTabWindow_Medicine.CountHasChanged = true; //why is this here? do we need this line?
				}

			}
			return ttabRecord;
		}

		private const float MaxTabWidth = 200f;

		public const float TabHeight = 32f;

		public const float TabHoriztonalOverlap = 10f;

		private static List<TabRecord> tmpTabs = new List<TabRecord>();
	}
}
