﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Verse;
using RimWorld;
using System.Reflection.Emit;
using HarmonyLib;

namespace ChooseYourMedicine
{
    class DrawHediffListing_Transpiler
    {
        //setting lastMaxIconsTotalWidth to 70f (90f if devmode is activated). Otherwise the rect width for the hediffs label may take the whole line.
        public static IEnumerable<CodeInstruction> DrawHediffListingTranspiler(IEnumerable<CodeInstruction> codeInstructions)
        {
            var codes = codeInstructions.ToList();
            var lastMaxIconsTotalWidth = AccessTools.Field(typeof(HealthCardUtility), "lastMaxIconsTotalWidth");
            for (var i = 0; i < codes.Count; i++)
            {
                var code = codes[i];
                if (i > 40 && code.opcode == OpCodes.Ldc_R4 && codes[i+1].StoresField(lastMaxIconsTotalWidth))
                {
                    code = new CodeInstruction(OpCodes.Call, AccessTools.Method(typeof(DrawHediffListing_Transpiler), nameof(DrawHediffListing_Transpiler.LastMaxIconsTotalWidth)));
                }
                yield return code;
            }
        }

        public static float LastMaxIconsTotalWidth()
        {
            return (DebugSettings.ShowDevGizmos && Current.ProgramState == ProgramState.Playing) ? 115f : 70f;
        }
    }
}
