﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using Verse.AI;
using HarmonyLib;
using System.Reflection;
using System.Reflection.Emit;

namespace ChooseYourMedicine
{
    [HarmonyPatch]
    class TendEntity_MakeNewToil_Transpiler
    {

    //see Harmony_JobDriver_TendPatient.MakeNewToil_Transpiler

        static MethodBase TargetMethod()
        {
            var predicateClass = typeof(JobDriver_TendEntity);
            return predicateClass.GetMethods(AccessTools.all).FirstOrDefault(m => m.Name.Contains("b__15_0"));
        }

        public static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instructions)
        {
            var codes = new List<CodeInstruction>(instructions);
            for (var i = 0; i < codes.Count; i++)
            {
                if (i > 10 && codes[i].opcode == OpCodes.Ldloc_0 && codes[i - 1].opcode == OpCodes.Brfalse_S && codes[i + 7].opcode == OpCodes.Brtrue_S)
                {
                    for (var j = 0; j < 10; j++)
                    {
                        codes[i + j].opcode = OpCodes.Nop;
                    }
                    break;
                }
            }
            return codes.AsEnumerable();
        }
    }
}
