﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;
using Verse.AI;

namespace ChooseYourMedicine
{
    public static class FindMoreMedicineToil_Prefix
    {
		//Pardon the bad comment...
		//In vanilla the doctor takes as many (max 10) medicine as necessary to tend a patient.
		//So it is only necessary to look for new medicine while tending, if the stack the medicine came from is empty/destroyed, as the "Thing medicine" the doc carries is still linked to the stack it came from
		//But because we eventually change the type of medicine while tending (and the amount of medicine the doc took for the prior tending), it happens that the stack is not null/empty.
		//But then the doc tends following hediffs without medicine.
		//Thats why we need to add the "else statement".
		//For compatibility reasons we should make a transpiler, but I cant right now, so a prefix...
        public static bool Prefix(ref Toil __result, Pawn doctor, Pawn patient, Thing medicine, Job job, Toil reserveMedicine)
        {
			Toil toil = ToilMaker.MakeToil("FindMoreMedicineToil");
			toil.initAction = delegate ()
			{
				//vanilla
				if (medicine.DestroyedOrNull())
				{
					Thing thing = HealthAIUtility.FindBestMedicine(doctor, patient, false);
					if (thing != null)
					{
						job.targetB = thing;
						doctor.jobs.curDriver.JumpToToil(reserveMedicine);
					}
				}
				//added by me
				else
				{
					int numberCarrying = doctor.carryTracker?.CarriedThing?.stackCount ?? 0;
					if (numberCarrying == 0)
					{
						Thing thing = HealthAIUtility.FindBestMedicine(doctor, patient, false);
						job.targetB = thing;
						doctor.jobs.curDriver.JumpToToil(reserveMedicine);
					}
				}
			};
			__result = toil;
			return false;
		}
    }
}
