﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RimWorld;
using Verse;

namespace ChooseYourMedicine
{
    public static class Clipboard
    {

        //if we have a whole list (page) in the clipBoard: indexList = x,  indexEntry = 999, indexColumn = 999;
        //if we have a row in the clipBoard: indexList = x; indexEntry = y; indexColumn = 999;
        //if we have a column in the clipBoard: indexList = x; indexEntry = 999; indexColum = z;
        public static int indexList = 999;
        public static int indexEntry = 999;
        public static int indexColumn = 999;

        public static void ClearClipboard()
        {
            Clipboard.indexList = 999;
            Clipboard.indexEntry = 999;
            Clipboard.indexColumn = 999;
        }

        public static void CopyListButton(int indexList)
        {
            Clipboard.indexList = indexList;
            Clipboard.indexEntry = 999;
            Clipboard.indexColumn = 999;
        }

        public static void CopyRowButton(int indexList, int indexEntry)
        {
            Clipboard.indexList = indexList;
            Clipboard.indexEntry = indexEntry;
            Clipboard.indexColumn = 999;
        }

        public static void CopyColumnButton(int indexList, int indexColumn)
        {
            Clipboard.indexList = indexList;
            Clipboard.indexEntry = 999;
            Clipboard.indexColumn = indexColumn;
        }

        public static void PasteListButton(int actualDisplayedList)
        {
            List<MedicineEntryList> lists = Utility_GetList.GetList();

            //We have a list in the clipboard, so we remove the list we see right now and replace it with the one we copied
            if (Clipboard.indexList != 999 && Clipboard.indexEntry == 999 && Clipboard.indexColumn == 999)
            {
                MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                //listToCopy.nameOfTheList = lists[actualDisplayedList].nameOfTheList;
                lists.Remove(lists[actualDisplayedList]);
                lists.Insert(actualDisplayedList, listToCopy);
                return;
            }

            //We have a entry (row) in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry != 999 && Clipboard.indexColumn == 999)
            {

                Find.WindowStack.Add(Dialog_MessageBox.CreateConfirmation("Kopp_CYM_PasteRowInList".Translate(), delegate
                {
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[Clipboard.indexEntry]);
                        if (entryToCopy.hasCompImmunizable)
                        {
                            entry.careCategoryEasy = entryToCopy.careCategoryEasy;
                            entry.careCategoryStandard = entryToCopy.careCategoryStandard;
                            entry.careCategoryProblematic = entryToCopy.careCategoryProblematic;
                            entry.careCategoryImmunityLower = entryToCopy.careCategoryImmunityLower;
                            entry.offSetEasy = entryToCopy.offSetEasy;
                            entry.offSetProblematic = entryToCopy.offSetProblematic;
                            entry.offSetImmunityLower = entryToCopy.offSetImmunityLower;
                        }
                        else
                        {
                            entry.careCategoryStandard = entryToCopy.careCategoryStandard;
                        }
                    }
                }, true, null, WindowLayer.Dialog));
                return;
            }

            //We have a column in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry == 999 && Clipboard.indexColumn != 999)
            {
                if (Clipboard.indexColumn == 0)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryEasy = entryToCopy.careCategoryEasy;
                        entry.offSetEasy = entryToCopy.offSetEasy;
                        index++;
                    }
                    return;
                }
                if (Clipboard.indexColumn == 1)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryStandard = entryToCopy.careCategoryStandard;
                        index++;
                    }
                    return;
                }
                if (Clipboard.indexColumn == 2)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryProblematic = entryToCopy.careCategoryProblematic;
                        entry.offSetProblematic = entryToCopy.offSetProblematic;
                        index++;
                    }
                    return;
                }
                if (Clipboard.indexColumn == 3)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryImmunityLower = entryToCopy.careCategoryImmunityLower;
                        entry.offSetImmunityLower = entryToCopy.offSetImmunityLower;
                        index++;
                    }
                    return;
                }
            }
        }
        public static void PasteRowButton(int actualDisplayedList, int indexOfActualRow)
        {
            List<MedicineEntryList> lists = Utility_GetList.GetList();

            //We have a list in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry == 999 && Clipboard.indexColumn == 999)
            {
                MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                lists[actualDisplayedList].list[indexOfActualRow].careCategoryEasy = listToCopy.list[indexOfActualRow].careCategoryEasy;
                lists[actualDisplayedList].list[indexOfActualRow].careCategoryStandard = listToCopy.list[indexOfActualRow].careCategoryStandard;
                lists[actualDisplayedList].list[indexOfActualRow].careCategoryProblematic = listToCopy.list[indexOfActualRow].careCategoryProblematic;
                lists[actualDisplayedList].list[indexOfActualRow].careCategoryImmunityLower = listToCopy.list[indexOfActualRow].careCategoryImmunityLower;
                lists[actualDisplayedList].list[indexOfActualRow].offSetEasy = listToCopy.list[indexOfActualRow].offSetEasy;
                lists[actualDisplayedList].list[indexOfActualRow].offSetProblematic = listToCopy.list[indexOfActualRow].offSetProblematic;
                lists[actualDisplayedList].list[indexOfActualRow].offSetImmunityLower = listToCopy.list[indexOfActualRow].offSetImmunityLower;
                return;
            }

            //We have a entry (row) in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry != 999 && Clipboard.indexColumn == 999)
            {
                MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                if (listToCopy.list[Clipboard.indexEntry].hasCompImmunizable)
                {
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryEasy = listToCopy.list[Clipboard.indexEntry].careCategoryEasy;
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryStandard = listToCopy.list[Clipboard.indexEntry].careCategoryStandard;
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryProblematic = listToCopy.list[Clipboard.indexEntry].careCategoryProblematic;
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryImmunityLower = listToCopy.list[Clipboard.indexEntry].careCategoryImmunityLower;
                    lists[actualDisplayedList].list[indexOfActualRow].offSetEasy = listToCopy.list[Clipboard.indexEntry].offSetEasy;
                    lists[actualDisplayedList].list[indexOfActualRow].offSetProblematic = listToCopy.list[Clipboard.indexEntry].offSetProblematic;
                    lists[actualDisplayedList].list[indexOfActualRow].offSetImmunityLower = listToCopy.list[Clipboard.indexEntry].offSetImmunityLower;
                }
                else
                {
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryStandard = listToCopy.list[Clipboard.indexEntry].careCategoryStandard;
                }
                return;
            }

            //We have a column in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry == 999 && Clipboard.indexColumn != 999)
            {
                if (Clipboard.indexColumn == 0)
                {
                    MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryEasy = listToCopy.list[indexOfActualRow].careCategoryEasy;
                    lists[actualDisplayedList].list[indexOfActualRow].offSetEasy = listToCopy.list[indexOfActualRow].offSetEasy;
                    return;
                }
                if (Clipboard.indexColumn == 1)
                {
                    MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryStandard = listToCopy.list[indexOfActualRow].careCategoryStandard;
                    return;
                }
                if (Clipboard.indexColumn == 2)
                {
                    MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);

                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryProblematic = listToCopy.list[indexOfActualRow].careCategoryProblematic;
                    lists[actualDisplayedList].list[indexOfActualRow].offSetProblematic = listToCopy.list[indexOfActualRow].offSetProblematic;
                    return;
                }
                if (Clipboard.indexColumn == 3)
                {
                    MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                    lists[actualDisplayedList].list[indexOfActualRow].careCategoryImmunityLower = listToCopy.list[indexOfActualRow].careCategoryImmunityLower;
                    lists[actualDisplayedList].list[indexOfActualRow].offSetImmunityLower = listToCopy.list[indexOfActualRow].offSetImmunityLower;
                    return;
                }
            }
        }

        public static void PasteColumnButton(int actualDisplayedList, int indexOfActualColumn)
        {
            List<MedicineEntryList> lists = Utility_GetList.GetList();

            //We have a list in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry == 999 && Clipboard.indexColumn == 999)
            {
                if (indexOfActualColumn == 0)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryEasy = entryToCopy.careCategoryEasy;
                        entry.offSetEasy = entryToCopy.offSetEasy;
                        index++;
                    }
                    return;
                }
                if (indexOfActualColumn == 1)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryStandard = entryToCopy.careCategoryStandard;
                        index++;
                    }
                    return;
                }
                if (indexOfActualColumn == 2)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryProblematic = entryToCopy.careCategoryProblematic;
                        entry.offSetProblematic = entryToCopy.offSetProblematic;
                        index++;
                    }
                    return;
                }
                if (indexOfActualColumn == 3)
                {
                    int index = 0;
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[index]);
                        entry.careCategoryImmunityLower = entryToCopy.careCategoryImmunityLower;
                        entry.offSetImmunityLower = entryToCopy.offSetImmunityLower;
                        index++;
                    }
                    return;
                }
            }

            //We have a entry (row) in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry != 999 && Clipboard.indexColumn == 999)
            {
                MedicineEntry entryToCopy = new MedicineEntry(lists[Clipboard.indexList].list[indexEntry]);
                if (indexOfActualColumn == 0)
                {
                    if (entryToCopy.hasCompImmunizable)
                    {
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            entry.careCategoryEasy = entryToCopy.careCategoryEasy;
                            entry.offSetEasy = entryToCopy.offSetEasy;
                        }
                    }
                    return;
                }
                if (indexOfActualColumn == 1)
                {
                    foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                    {
                        entry.careCategoryStandard = entryToCopy.careCategoryStandard;
                    }
                    return;
                }
                if (indexOfActualColumn == 2)
                {
                    if (entryToCopy.hasCompImmunizable)
                    {
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            entry.careCategoryProblematic = entryToCopy.careCategoryProblematic;
                            entry.offSetProblematic = entryToCopy.offSetProblematic;
                        }
                    }
                    return;
                }
                if (indexOfActualColumn == 3)
                {
                    if (entryToCopy.hasCompImmunizable)
                    {
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            entry.careCategoryImmunityLower = entryToCopy.careCategoryImmunityLower;
                            entry.offSetImmunityLower = entryToCopy.offSetImmunityLower;
                        }
                    }
                    return;
                }
            }
            //We have a column in the clipboard
            if (Clipboard.indexList != 999 && Clipboard.indexEntry == 999 && Clipboard.indexColumn != 999)
            {
                if (indexOfActualColumn == 0)
                {
                    if (Clipboard.indexColumn == 0)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryEasy = listToCopy.list[index].careCategoryEasy;
                            entry.offSetEasy = listToCopy.list[index].offSetEasy;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 1)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryEasy = listToCopy.list[index].careCategoryStandard;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 2)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryEasy = listToCopy.list[index].careCategoryProblematic;
                            entry.offSetEasy = listToCopy.list[index].offSetProblematic;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn ==3)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryEasy = listToCopy.list[index].careCategoryImmunityLower;
                            entry.offSetEasy = listToCopy.list[index].offSetImmunityLower;
                            index++;
                        }
                        return;
                    }
                }
                if (indexOfActualColumn == 1)
                {
                    if (Clipboard.indexColumn == 0)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            if (listToCopy.list[index].hasCompImmunizable)
                            {
                                entry.careCategoryStandard = listToCopy.list[index].careCategoryEasy;
                            }
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 1)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            if (listToCopy.list[index].hasCompImmunizable)
                            {
                                entry.careCategoryStandard = listToCopy.list[index].careCategoryStandard;
                            }
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 2)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            if (listToCopy.list[index].hasCompImmunizable)
                            {
                                entry.careCategoryStandard = listToCopy.list[index].careCategoryProblematic;
                            }
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 3)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            if (listToCopy.list[index].hasCompImmunizable)
                            {
                                entry.careCategoryStandard = listToCopy.list[index].careCategoryImmunityLower;
                            }
                            index++;
                        }
                        return;
                    }
                }
                if (indexOfActualColumn == 2)
                {
                    if (Clipboard.indexColumn == 0)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryProblematic = listToCopy.list[index].careCategoryEasy;
                            entry.offSetProblematic = listToCopy.list[index].offSetEasy;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 1)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryProblematic = listToCopy.list[index].careCategoryStandard;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 2)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryProblematic = listToCopy.list[index].careCategoryProblematic;
                            entry.offSetProblematic = listToCopy.list[index].offSetProblematic;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 3)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryProblematic = listToCopy.list[index].careCategoryImmunityLower;
                            entry.offSetProblematic = listToCopy.list[index].offSetImmunityLower;
                            index++;
                        }
                        return;
                    }
                }
                if (indexOfActualColumn == 3)
                {
                    if (Clipboard.indexColumn == 0)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryImmunityLower = listToCopy.list[index].careCategoryEasy;
                            entry.offSetImmunityLower = listToCopy.list[index].offSetEasy;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 1)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryImmunityLower = listToCopy.list[index].careCategoryStandard;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 2)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryImmunityLower = listToCopy.list[index].careCategoryProblematic;
                            entry.offSetImmunityLower = listToCopy.list[index].offSetProblematic;
                            index++;
                        }
                        return;
                    }
                    if (Clipboard.indexColumn == 3)
                    {
                        int index = 0;
                        MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                        foreach (MedicineEntry entry in lists[actualDisplayedList].list)
                        {
                            //MedicineEntryList listToCopy = new MedicineEntryList(lists[Clipboard.indexList]);
                            entry.careCategoryImmunityLower = listToCopy.list[index].careCategoryImmunityLower;
                            entry.offSetImmunityLower = listToCopy.list[index].offSetImmunityLower;
                            index++;
                        }
                        return;
                    }
                }
            }
        }

        public static void DefaultSettingsButton(int j)
        {

            List<FloatMenuOption> list = new List<FloatMenuOption>();
            for (int i = 0; i < 2; i++)
            {
                int idx = i;
                string testString = "";
                if (idx == 0) { testString = "Kopp_CYM_DefaultSettingsOneTab".Translate(); }
                if (idx == 1) { testString = "Kopp_CYM_DefaultSettingsAllTabs".Translate(); }
                list.Add(new FloatMenuOption(testString, delegate ()
                    {
                        //set only this tab to default settings
                        if (idx == 0)
                        {
                            Find.WindowStack.Add(Dialog_MessageBox.CreateConfirmation("Kopp_CYM_ConfirmationOneTab".Translate(), delegate
                            {
                                List<MedicineEntryList> lists = Utility_GetList.GetList();
                                if (j == 0 || j == 1) //colonist and imprisoned colonists tab
                                {
                                    foreach (MedicineEntry entry in lists[j].list)
                                    {
                                        entry.careCategoryEasy = MedicalCareCategory.HerbalOrWorse;
                                        entry.careCategoryStandard = MedicalCareCategory.NormalOrWorse;
                                        entry.careCategoryProblematic = MedicalCareCategory.Best;
                                        entry.careCategoryImmunityLower = MedicalCareCategory.NormalOrWorse;
                                        entry.offSetEasy = 25;
                                        entry.offSetProblematic = 5;
                                        entry.offSetImmunityLower = 20;
                                        //entry.shouldBeHidden = false;
                                    }
                                }
                                if (j == 3 || j == 10) //ghouls and entities
                                {
                                    foreach (MedicineEntry entry in lists[j].list)
                                    {
                                        entry.careCategoryEasy = MedicalCareCategory.NoMeds;
                                        entry.careCategoryStandard = MedicalCareCategory.NoMeds;
                                        entry.careCategoryProblematic = MedicalCareCategory.NoMeds;
                                        entry.careCategoryImmunityLower = MedicalCareCategory.NoMeds;
                                        entry.offSetEasy = 25;
                                        entry.offSetProblematic = 5;
                                        entry.offSetImmunityLower = 20;
                                        //entry.shouldBeHidden = false;
                                    }
                                }
                                else //all the other tabs
                                {
                                    foreach (MedicineEntry entry in lists[j].list)
                                    {
                                        entry.careCategoryEasy = MedicalCareCategory.NoMeds;
                                        entry.careCategoryStandard = MedicalCareCategory.HerbalOrWorse;
                                        entry.careCategoryProblematic = MedicalCareCategory.NormalOrWorse;
                                        entry.careCategoryImmunityLower = MedicalCareCategory.HerbalOrWorse;
                                        entry.offSetEasy = 25;
                                        entry.offSetProblematic = 5;
                                        entry.offSetImmunityLower = 20;
                                        //entry.shouldBeHidden = false;
                                    }
                                }

                                ModSettings.settings.lists = lists;
                                ModSettings.Write();
                                MainTabWindow_Medicine.listsHaveChanged = true;
                                Clipboard.ClearClipboard();

                            }, true, null, WindowLayer.Dialog));
                        }

                        //set all tabs to default settings
                        if (idx == 1)
                        {
                            Find.WindowStack.Add(Dialog_MessageBox.CreateConfirmation("Kopp_CYM_ConfirmationAllTabs".Translate(), delegate
                            {
                                MedicineEntryListsCreation defaultListsCreation = new MedicineEntryListsCreation();
                                defaultListsCreation.CreateDefaultConfigs();
                                ModSettings.Write();
                                MainTabWindow_Medicine.listsHaveChanged = true;
                                Clipboard.ClearClipboard();
                            }, true, null, WindowLayer.Dialog));
                        }


                    }, MenuOptionPriority.Default, null, null, 0f, null, null, true, 0));
            }
            Find.WindowStack.Add(new FloatMenu(list));






        }


        //If mods that introduce new hediffs got added or mods got removed that included hediffs, we need to remove/add the hediffs
        public static void RefreshHediffListsButton()
        {
            //We need to check what hediffs we have in the list
            List<MedicineEntryList> lists = Utility_GetList.GetList();
            List<HediffDef> hediffsWeHave = new List<HediffDef>();

            foreach (MedicineEntry entry in lists[0].list)
            {
                HediffDef hediffDef = DefDatabase<HediffDef>.GetNamed(entry.defName, false);
                if (hediffDef != null)
                {
                    hediffsWeHave.Add(hediffDef);
                }
            }

            //We need to check what tendable hediffs the game has
            MedicineEntryListsCreation medicineEntryListsCreation = new MedicineEntryListsCreation();
            List<HediffDef> hediffsWeWant = medicineEntryListsCreation.GetAllTendableHediffs();


            //If the game has hediffs that are not in our list, we need to add them.
            int entryCount = lists.Count();
            IEnumerable<HediffDef> hediffsWeNeedToAdd = hediffsWeWant.Except(hediffsWeHave);
            if (hediffsWeNeedToAdd.Any())
            {
                foreach (HediffDef hediff in hediffsWeNeedToAdd)
                {
                    for (int i = 0; i < entryCount; i++)
                    {
                        MedicineEntry entry = new MedicineEntry();
                        entry.defName = hediff.defName;
                        entry.label = hediff.label;
                        entry.offSetEasy = 25;
                        entry.offSetProblematic = 5;
                        entry.offSetImmunityLower = 20;
                        entry.shouldBeHidden = false;
                        entry.hasCompImmunizable = hediff.HasComp(typeof(HediffComp_Immunizable));
                        if (i == 0 || i == 1) //colonist and imprisoned colonists tab
                        {
                            entry.careCategoryEasy = MedicalCareCategory.HerbalOrWorse;
                            entry.careCategoryStandard = MedicalCareCategory.NormalOrWorse;
                            entry.careCategoryProblematic = MedicalCareCategory.Best;
                            entry.careCategoryImmunityLower = MedicalCareCategory.NormalOrWorse;
                        }
                        else if (i == 3 || i == 10) //ghouls and entities
                        {
                            entry.careCategoryEasy = MedicalCareCategory.NoMeds;
                            entry.careCategoryStandard = MedicalCareCategory.NoMeds;
                            entry.careCategoryProblematic = MedicalCareCategory.NoMeds;
                            entry.careCategoryImmunityLower = MedicalCareCategory.NoMeds;
                        }
                        else
                        {
                            entry.careCategoryEasy = MedicalCareCategory.NoMeds;
                            entry.careCategoryStandard = MedicalCareCategory.HerbalOrWorse;
                            entry.careCategoryProblematic = MedicalCareCategory.HerbalOrWorse;
                            entry.careCategoryImmunityLower = MedicalCareCategory.HerbalOrWorse;
                        }
                        lists[i].list.Add(entry);
                    }
                }
                //We need to reorder the list if we added something
                foreach (MedicineEntryList medicineEntryList in lists)
                {
                    IEnumerable<MedicineEntry> asd = medicineEntryList.list;
                    asd = asd.OrderBy(c => c.label).ThenBy(c => c.defName);
                    medicineEntryList.list = asd.ToList();
                }
            }

            //If our list has hediffs that are not in the games def database, we need to remove them.
            List<MedicineEntry> medicineEntriesToRemove = lists[0].list.Where(x => DefDatabase<HediffDef>.GetNamed(x.defName, false) == null).ToList();
            List<string> medicineEntriesToRemoveDefName = new List<string>();
            foreach (MedicineEntry entry in medicineEntriesToRemove)
            {
                medicineEntriesToRemoveDefName.Add(entry.defName);
            }
            List<string> hediffsToRemove = new List<string>();
            foreach (MedicineEntry entry in medicineEntriesToRemove)
            {
                hediffsToRemove.Add("defName: "+ entry.defName + "|| label: "+entry.label);
            }
            int countHediffsRemoved = hediffsToRemove.Count();
            foreach (MedicineEntryList entryList in lists)
            {
                entryList.list.RemoveAll(item => medicineEntriesToRemoveDefName.Contains(item.defName));
            }

            //Feedback for the removed/added entries
            int countHediffsAdded = hediffsWeNeedToAdd.Count();
            if (Current.ProgramState != ProgramState.Entry) //in a certain case we update the hediff list when being in main menu (or when opening mod settings in main menu), then no message, otherwise error
            {
                Messages.Message("Kopp_CYM_UpdateListFeedback".Translate(countHediffsRemoved, countHediffsAdded), MessageTypeDefOf.TaskCompletion, false);
            }
            if (countHediffsAdded > 0 || countHediffsRemoved > 0)
            {
                StringBuilder str = new StringBuilder();
                str.AppendLine("CHOOSE YOUR MEDICINE: THE FOLLOWING HEDIFFS GOT ADDED/REMOVED".Colorize(UnityEngine.Color.yellow));
                if (countHediffsAdded > 0)
                {
                    str.AppendInNewLine("Added:");
                    foreach (HediffDef hediffAdded in hediffsWeNeedToAdd)
                    {
                        str.AppendInNewLine("defName: " + hediffAdded.defName + "|| label: "+hediffAdded.label);
                    }
                }
                if (countHediffsRemoved > 0)
                {
                    str.AppendInNewLine("Removed:");
                    foreach (string hediffRemoved in hediffsToRemove)
                    {
                        str.AppendInNewLine(hediffRemoved);
                    }
                }
                str.AppendInNewLine(" ");
                Log.Message(str.ToString());
            }

            MainTabWindow_Medicine.CountHasChanged = true;
            ModSettings.settings.lists = lists;
            ModSettings.Write();
            MainTabWindow_Medicine.listsHaveChanged = true;
            Clipboard.ClearClipboard();
        }
    }
}
